package Socket;
#
# $Id$
#
# $Log$
#
# 

$AF_INET = 2;
$SOCK_STREAM = 1;
$sockaddr = 'S n a4 x8';
($name,  $aliases,  $proto)  = getprotobyname( 'tcp') ;

#
# Create a file_handle for a socket.
#
sub handle			
{
    local ($socket) = @_;

    socket ($socket,  $AF_INET,  $SOCK_STREAM,  $proto)
	||  die "socket:  $!";
}

# 
# Get a network address from a hostname given either by name or
# as four decimal numbers separated by dots.
#
# If the hostname is ommitted, then the local host's address will
# be returned.
#
sub address
{
    local($host) = @_;
    local($addr);

    if($host eq '0')
    {
	$addr = "\0\0\0\0";
    }
    elsif(! $host)
    {
	if(! $hostname)
	{
	    chop($hostname=`hostname`) if ! $hostname;
	    ($name,$aliases,$type,$len,$hostaddr)
		= gethostbyname($hostname);
	}
	$addr = $hostaddr;
    }
    else
    {
	if($host =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)
	{
	    pack($addr,'C4',$1,$2,$3,$4);
	}
	else
	{
	    ($name,$aliases,$type,$len,$addr)
		= gethostbyname($host);
	}
    }
    
    return $addr;
}

# 
# Get a socket address for a port and host.
# If the port is 0, then a port number will be assigned.
#   (ie you don't care which port is used.
# If the host is null, then use the current host. 
#
sub socket_address
{
    local($port,$host) = @_;
    local($addr);

    $addr = &address($host);

    ($name, $aliases, $port)  = getservbyname($port,'tcp')
	unless $port =~ /^\d+$/;;

    $addr = pack($sockaddr,$AF_INET, $port, $addr);
}

#
# Create a file_handle for a socket, and bind it to a port.
#
sub server
{
    local ($socket,$port) = @_;
    local ($this);

    &handle($socket);
    $this = &socket_address($port,0);
    bind($socket,$this) || die "bind: $!";
    listen($socket,5) || die "listen: $!";
}

#
# Arguments are a socket address and a message.
#
sub client
{
    local($socket,$host,$port) = @_;

    $addr = &socket_address($port,$host);

    &handle($socket);
    bind($socket,&socket_address(0));
    select($socket); $| = 1; select(STDOUT);
    connect($socket,$addr) || return 0;

    1;
}

#
# Send a simple message and get a response
#
sub send
{
    local($host,$port,$message) = @_;

    &client(SEND,$host,$port) || return '';

    if(print SEND $message, "\n")
    {
        $_ = <SEND>;        
	if($_)
	{
	    close(SEND);
	    chop;
	    return $_;
	}
    }
    close(SEND);
    '';
}
