#!/usr/bin/perl -- # -*- perl -*-
#
# $Id: dougs_server.pl,v 1.1 1994/01/10 20:02:08 jfulton Exp jfulton $
#
# command - description
#
# THIS SOFTWARE HAS *NOT* BEEN APPROVED FOR RELEASE TO THE PUBLIC.
#
# THIS SOFTWARE MAY ONLY BE PROVIDED TO INDIVIDUALS WHO ARE CO-DEVELOPERS,
# REVIEWERS, OR TESTERS, OR TO PERSONNEL OF THE U.S. GEOLOGICAL SURVEY.
#
#  DISCLAIMER:
#    ALTHOUGH THIS PROGRAM HAS BEEN USED BY THE U.S. GEOLOGICAL
#    SURVEY, NO WARRANTY, EXPRESSED OR IMPLIED, IS MADE BY THE
#    USGS AS TO THE ACCURACY AND FUNCTIONING OF THE PROGRAM AND
#    RELATED PROGRAM MATERIAL NOR SHALL THE FACT OF DISTRIBUTION
#    CONSTITUTE ANY SUCH WARRANTY, AND NO RESPONSIBILITY IS
#    ASSUMED BY THE USGS IN CONNECTION HEREWITH.
#  
#
# If you have questions regarding this software,
# contact:
#
#   Jim Fulton, jfulton@qvarsx.er.usgs.gov,
#   U.S. Geological Survey
#   445 National Center
#   Reston, Virginia, 22092, USA
#
#   (703) 648-5622
#
# Revision 1.1  1994/01/10  20:02:08  jfulton
# Revision 1.2  1994/01/10  ddnebert Added all functions to netlib vocabulary
#
#
# 

$RCS_ID = '$Id: dougs_server.pl,v 1.1 1994/01/10 20:02:08 jfulton Exp jfulton $' ;
($pgm  = $0) =~ s-.*/-- ;

# Check for arguments...
if ($#ARGV == 0) {
   die "Usage: netlibserver <TCP-IP_port_number> <logfile_path>\n";
   }

$port = $ARGV[0];

# Check for high numbered (non-UNIX reserved) ports...
if ($port <= 1024) {
   die "Please select port number greater than 1024\n...Exiting.\n";
   }

$lfile = $ARGV[1];

# Check to be sure log file is writable, and if not there create it...

open(LOG,">>$lfile") || die "Unable to create log file $lfile\nExiting.\n";

#Tell the invoker about it...
print LOG "Started netlibserver on port $port \n";

$bin = "$ENV{'ARCHOME'}/atool/support/arcsupport/netlib";
%valid = ('gethosts',1,'pinghost',1,'getlib',1,'getlayer',1,'getdoc',1,'getprj',1,'extract');
$illegal = '[^\w\s.:/]';

require('Socket.pl');

select LOG; $| = 1;

&Socket'server(Socket'CONNECTIONS,$port);

sub error
{
    print LOG "@_\n";
    close(TRANSACTION);
}

while(1)
{
   accept(TRANSACTION,Socket'CONNECTIONS) #')
     || die "accept: $!";
   @peerinfo = unpack('S n a4 x8', getpeername(TRANSACTION));
   @peerhost = gethostbyaddr($peerinfo[2],$Socket'AF_INET);
   print LOG "$peerhost[0] ";
   $request = <TRANSACTION>;
   chop($request);
   @request = split(/\s/,$request);
   $program = $request[0];
   &error("Bad request: $request"), next
       if ! $valid{$program} || $request =~ /$illegal/o;
   open(PROG,"$bin/$request|") || &error("Could not $request");
   while(<PROG>)
   {
       print TRANSACTION;
   }
   close TRANSACTION;
   print LOG "OK: $request\n";
}
